package at.ac.uibk.gitsearch.domain;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

@Entity
public class ReviewComment implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(nullable = true)
    private Boolean descriptionIsClear;

    @Column(nullable = true)
    private Boolean requirementsAreClear;

    @Column(nullable = true)
    private String descriptionComment;

    @Column(nullable = true)
    private Boolean informationRequiredComplete;

    @Column(nullable = true)
    private Boolean allMaterialsAvailable;

    @Column(nullable = true)
    private String informationRequiredComment;

    @Column(nullable = true)
    private Boolean isStructured;

    @Column(nullable = true)
    private Boolean subExercisesAreClear;

    @Column(nullable = true)
    private String structuredComment;

    @Column(nullable = true)
    private Boolean solutionIsCorrect;

    @Column(nullable = true)
    private String solutionComment;

    @Column(nullable = true)
    private Boolean metadataIsComplete;

    @Column(nullable = true)
    private Boolean metadataIsCorrect;

    @Column(nullable = true)
    private String metadataComment;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Boolean getDescriptionIsClear() {
        return descriptionIsClear;
    }

    public void setDescriptionIsClear(Boolean descriptionIsClear) {
        this.descriptionIsClear = descriptionIsClear;
    }

    public Boolean getRequirementsAreClear() {
        return requirementsAreClear;
    }

    public void setRequirementsAreClear(Boolean requirementsAreClear) {
        this.requirementsAreClear = requirementsAreClear;
    }

    public String getDescriptionComment() {
        return descriptionComment;
    }

    public void setDescriptionComment(String descriptionComment) {
        this.descriptionComment = descriptionComment;
    }

    public Boolean getInformationRequiredComplete() {
        return informationRequiredComplete;
    }

    public void setInformationRequiredComplete(Boolean informationRequiredComplete) {
        this.informationRequiredComplete = informationRequiredComplete;
    }

    public Boolean getAllMaterialsAvailable() {
        return allMaterialsAvailable;
    }

    public void setAllMaterialsAvailable(Boolean allMaterialsAvailable) {
        this.allMaterialsAvailable = allMaterialsAvailable;
    }

    public String getInformationRequiredComment() {
        return informationRequiredComment;
    }

    public void setInformationRequiredComment(String informationRequiredComment) {
        this.informationRequiredComment = informationRequiredComment;
    }

    public Boolean getIsStructured() {
        return isStructured;
    }

    public void setIsStructured(Boolean isStructured) {
        this.isStructured = isStructured;
    }

    public Boolean getSubExercisesAreClear() {
        return subExercisesAreClear;
    }

    public void setSubExercisesAreClear(Boolean subExercisesAreClear) {
        this.subExercisesAreClear = subExercisesAreClear;
    }

    public String getStructuredComment() {
        return structuredComment;
    }

    public void setStructuredComment(String structuredComment) {
        this.structuredComment = structuredComment;
    }

    public Boolean getSolutionIsCorrect() {
        return solutionIsCorrect;
    }

    public void setSolutionIsCorrect(Boolean solutionIsCorrect) {
        this.solutionIsCorrect = solutionIsCorrect;
    }

    public String getSolutionComment() {
        return solutionComment;
    }

    public void setSolutionComment(String solutionComment) {
        this.solutionComment = solutionComment;
    }

    public Boolean getMetadataIsComplete() {
        return metadataIsComplete;
    }

    public void setMetadataIsComplete(Boolean metadataIsComplete) {
        this.metadataIsComplete = metadataIsComplete;
    }

    public Boolean getMetadataIsCorrect() {
        return metadataIsCorrect;
    }

    public void setMetadataIsCorrect(Boolean metadataIsCorrect) {
        this.metadataIsCorrect = metadataIsCorrect;
    }

    public String getMetadataComment() {
        return metadataComment;
    }

    public void setMetadataComment(String metadataComment) {
        this.metadataComment = metadataComment;
    }

    @Override
    @SuppressWarnings("PMD")
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        result = prime * result + ((descriptionIsClear == null) ? 0 : descriptionIsClear.hashCode());
        result = prime * result + ((requirementsAreClear == null) ? 0 : requirementsAreClear.hashCode());
        result = prime * result + ((descriptionComment == null) ? 0 : descriptionComment.hashCode());
        result = prime * result + ((informationRequiredComplete == null) ? 0 : informationRequiredComplete.hashCode());
        result = prime * result + ((allMaterialsAvailable == null) ? 0 : allMaterialsAvailable.hashCode());
        result = prime * result + ((informationRequiredComment == null) ? 0 : informationRequiredComment.hashCode());
        result = prime * result + ((isStructured == null) ? 0 : isStructured.hashCode());
        result = prime * result + ((subExercisesAreClear == null) ? 0 : subExercisesAreClear.hashCode());
        result = prime * result + ((structuredComment == null) ? 0 : structuredComment.hashCode());
        result = prime * result + ((solutionIsCorrect == null) ? 0 : solutionIsCorrect.hashCode());
        result = prime * result + ((solutionComment == null) ? 0 : solutionComment.hashCode());
        result = prime * result + ((metadataIsComplete == null) ? 0 : metadataIsComplete.hashCode());
        result = prime * result + ((metadataIsCorrect == null) ? 0 : metadataIsCorrect.hashCode());
        result = prime * result + ((metadataComment == null) ? 0 : metadataComment.hashCode());
        return result;
    }

    @Override
    @SuppressWarnings("PMD")
    public boolean equals(Object obj) {
        if (this == obj) return true;
        if (obj == null) return false;
        if (getClass() != obj.getClass()) return false;
        ReviewComment other = (ReviewComment) obj;
        if (id == null) {
            if (other.id != null) return false;
        } else if (!id.equals(other.id)) return false;
        if (descriptionIsClear == null) {
            if (other.descriptionIsClear != null) return false;
        } else if (!descriptionIsClear.equals(other.descriptionIsClear)) return false;
        if (requirementsAreClear == null) {
            if (other.requirementsAreClear != null) return false;
        } else if (!requirementsAreClear.equals(other.requirementsAreClear)) return false;
        if (descriptionComment == null) {
            if (other.descriptionComment != null) return false;
        } else if (!descriptionComment.equals(other.descriptionComment)) return false;
        if (informationRequiredComplete == null) {
            if (other.informationRequiredComplete != null) return false;
        } else if (!informationRequiredComplete.equals(other.informationRequiredComplete)) return false;
        if (allMaterialsAvailable == null) {
            if (other.allMaterialsAvailable != null) return false;
        } else if (!allMaterialsAvailable.equals(other.allMaterialsAvailable)) return false;
        if (informationRequiredComment == null) {
            if (other.informationRequiredComment != null) return false;
        } else if (!informationRequiredComment.equals(other.informationRequiredComment)) return false;
        if (isStructured == null) {
            if (other.isStructured != null) return false;
        } else if (!isStructured.equals(other.isStructured)) return false;
        if (subExercisesAreClear == null) {
            if (other.subExercisesAreClear != null) return false;
        } else if (!subExercisesAreClear.equals(other.subExercisesAreClear)) return false;
        if (structuredComment == null) {
            if (other.structuredComment != null) return false;
        } else if (!structuredComment.equals(other.structuredComment)) return false;
        if (solutionIsCorrect == null) {
            if (other.solutionIsCorrect != null) return false;
        } else if (!solutionIsCorrect.equals(other.solutionIsCorrect)) return false;
        if (solutionComment == null) {
            if (other.solutionComment != null) return false;
        } else if (!solutionComment.equals(other.solutionComment)) return false;
        if (metadataIsComplete == null) {
            if (other.metadataIsComplete != null) return false;
        } else if (!metadataIsComplete.equals(other.metadataIsComplete)) return false;
        if (metadataIsCorrect == null) {
            if (other.metadataIsCorrect != null) return false;
        } else if (!metadataIsCorrect.equals(other.metadataIsCorrect)) return false;
        if (metadataComment == null) {
            if (other.metadataComment != null) return false;
        } else if (!metadataComment.equals(other.metadataComment)) return false;
        return true;
    }
}
