package at.ac.uibk.gitsearch.service;

import at.ac.uibk.gitsearch.domain.User;
import at.ac.uibk.gitsearch.repository.jpa.AuthorityRepository;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class AuthorityService {

    private final Logger log = LoggerFactory.getLogger(AuthorityService.class);

    private final AuthorityRepository authorityRepository;

    public AuthorityService(AuthorityRepository authorityRepository) {
        this.authorityRepository = authorityRepository;
    }

    List<User> findAllUsersWithAuthority(String authority) {
        log.info("Finding all users with authority: {}", authority);
        List<User> users = authorityRepository.findAllUsersWithAuthority(authority);
        log.info("Found {} users with authority: {}", users.size(), authority);
        return users;
    }
}
